import vimet.*;
import java.awt.Container;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsEnvironment;
import java.awt.GraphicsDevice;
import javax.media.j3d.*;
import javax.swing.JFrame;
import vimet.object.Object3D;
import wizard.FunctionsClass;
import util.ObjectTypeEnum;
import Collision.*;
import deformation.*;
import util.FileTypeEnum;
import javax.vecmath.*;
import deformationNew.DeformacaoNova;
import vimet.loaders.MfLoader;
public class Jul23_Mult_Coll extends Environment{
//atributos 
// - Lista de objetos no universo
private Object3D organs[];
private Object3D instrument;
private static Keyboard keyboard = null;
public Jul23_Mult_Coll(Canvas3D c) {
	super(c, false);
try {
Transform3D transform;
//Instanciacao dos atributos
// - Instanciacao dos objetos
organs = new Object3D[2];
organs [0] = FunctionsClass.loadObject("./objects/organs/mama2537.off", ObjectTypeEnum.ORGAN, FileTypeEnum.MF );
transform = new Transform3D();
transform.setScale(new Vector3d(0.016, 0.016, 0.016)); 
transform.setTranslation(new Vector3d(-0.1, -0.1, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
organs [0].setTransformGroup(new TransformGroup(transform));
organs [1] = FunctionsClass.loadObject("./objects/organs/mama.off", ObjectTypeEnum.INTERNAL, FileTypeEnum.MF );
transform = new Transform3D();
transform.setScale(new Vector3d(0.016, 0.016, 0.016)); 
transform.setTranslation(new Vector3d(0.001, -0.1, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
organs [1].setTransformGroup(new TransformGroup(transform));
organs [1].getShape3d().setCollidable(false);
instrument = FunctionsClass.loadObject("./objects/instruments/seringa.obj", ObjectTypeEnum.INSTRUMENT, FileTypeEnum.OBJ );
transform = new Transform3D();
transform.setScale(new Vector3d(0.13, 0.13, 0.13)); 
transform.setTranslation(new Vector3d(-0.6, -0.1, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
instrument.setTransformGroup(new TransformGroup(transform));
// - Instanciacao da deteccao de colisao
Octree cd = new Octree(organs[0].getShape3d());
cd.setPrecision(0.001);
cd.setSchedulingBounds(organs[0].getShape3d().getBounds());
organs [0].getShape3d().setCollidable(false);
// - Instanciacao da deformacao
		Parameters p = new Parameters();
float forca = 250f;
DeformacaoNova novaDeformacao = new DeformacaoNova((MfLoader)organs[0].loaderObject,forca);
cd.setNovaDeformacao(novaDeformacao);
cd.setObjetoInterseccao(organs);
cd.setAplicacao(this);
BranchGroup bgTemp = new BranchGroup();
		bgTemp.addChild(cd);
bgTemp.setCapability(BranchGroup.ALLOW_DETACH);
 cd.setBranchColisao(bgTemp);
		super.myLocale.addBranchGraph(bgTemp);
//Adicao dos objetos no universo
this.add(organs[0]);
this.add(organs[1]);
this.add(instrument);
TMouse mouse = new TMouse( instrument.getTransformGroup(), super.myLocale);
 } catch (Exception e) {
e.printStackTrace();
}
}
	public static void main (String arg[]){
GraphicsConfigTemplate3D g3d = new GraphicsConfigTemplate3D();
GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
GraphicsDevice defaultScreen = ge.getDefaultScreenDevice();
GraphicsConfiguration gcn = defaultScreen.getBestConfiguration(g3d);
Canvas3D c = new Canvas3D(gcn);
		Jul23_Mult_Coll n = new Jul23_Mult_Coll(c);
JFrame frm = new JFrame("Jul23_Mult_Coll");
Container ct = frm.getContentPane();
c.addKeyListener(keyboard);
ct.add(c);
frm.setSize(1000,800);
frm.setVisible(true);
frm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
}
}
