import vimet.*;
import java.awt.Container;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsEnvironment;
import java.awt.GraphicsDevice;
import javax.media.j3d.*;
import javax.swing.JFrame;
import vimet.object.Object3D;
import wizard.FunctionsClass;
import util.ObjectTypeEnum;
import Collision.*;
import deformation.*;
import util.FileTypeEnum;
import javax.vecmath.*;
import deformationNew.DeformacaoNova;
import vimet.loaders.MfLoader;
public class Jun27_Ilumoff extends Environment{
//atributos 
// - Lista de objetos no universo
private Object3D organs[];
private Object3D instrument;
private static Keyboard keyboard = null;
public Jun27_Ilumoff(Canvas3D c) {
	super(c, true, " Negra ", " Direcional ");
try {
Transform3D transform;
//Instanciacao dos atributos
// - Instanciacao dos objetos
organs = new Object3D[3];
organs [0] = FunctionsClass.loadObject("./objects/organs/mama2537.off", ObjectTypeEnum.ORGAN, FileTypeEnum.MF );
organs [0].setApplyIlumination(true);
transform = new Transform3D();
transform.setScale(new Vector3d(0.009, 0.009, 0.009)); 
transform.setTranslation(new Vector3d(0.008, -0.2, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
organs [0].setTransformGroup(new TransformGroup(transform));
organs [1] = FunctionsClass.loadObject("./objects/organs/mama.obj", ObjectTypeEnum.INTERNAL, FileTypeEnum.OBJ );
organs [1].setApplyIlumination(true);
transform = new Transform3D();
transform.setScale(new Vector3d(0.18, 0.18, 0.18)); 
transform.setTranslation(new Vector3d(-0.4, -0.2, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
organs [1].setTransformGroup(new TransformGroup(transform));
organs [1].getShape3d().setCollidable(false);
organs [2] = FunctionsClass.loadObject("./objects/organs/mama.obj", ObjectTypeEnum.INTERNAL, FileTypeEnum.OBJ );
organs [2].setApplyIlumination(true);
transform = new Transform3D();
transform.setScale(new Vector3d(0.18, 0.18, 0.18)); 
transform.setTranslation(new Vector3d(0.3, -0.2, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
organs [2].setTransformGroup(new TransformGroup(transform));
organs [2].getShape3d().setCollidable(false);
instrument = FunctionsClass.loadObject("./objects/instruments/seringa.obj", ObjectTypeEnum.INSTRUMENT, FileTypeEnum.OBJ );
instrument.setApplyIlumination(true);
transform = new Transform3D();
transform.setScale(new Vector3d(0.14, 0.14, 0.14)); 
transform.setTranslation(new Vector3d(-0.5, 0.1, 0.0)); 
transform.setRotation(new AxisAngle4d(0.0, 0.0, 0.0, 0.0)); 
instrument.setTransformGroup(new TransformGroup(transform));
// - Estereoscopia
super.setEyeOffset(0.017f);
// - Instanciacao da deteccao de colisao
Octree cd = new Octree(organs[0].getShape3d());
cd.setPrecision(0.001);
cd.setSchedulingBounds(organs[0].getShape3d().getBounds());
// - Instanciacao da deformacao
		Parameters p = new Parameters();
float forca = 250f;
DeformacaoNova novaDeformacao = new DeformacaoNova((MfLoader)organs[0].loaderObject,forca);
cd.setNovaDeformacao(novaDeformacao);
BranchGroup bgTemp = new BranchGroup();
		bgTemp.addChild(cd);
		super.myLocale.addBranchGraph(bgTemp);
//Adicao dos objetos no universo
this.add(organs[0]);
this.add(organs[1]);
this.add(organs[2]);
super.setCor("instrumento");
this.add(instrument);
TMouse mouse = new TMouse( instrument.getTransformGroup(), super.myLocale);
 } catch (Exception e) {
e.printStackTrace();
}
}
	public static void main (String arg[]){
GraphicsConfigTemplate3D g3d = new GraphicsConfigTemplate3D();
GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
GraphicsDevice defaultScreen = ge.getDefaultScreenDevice();
GraphicsConfiguration gcn = defaultScreen.getBestConfiguration(g3d);
Canvas3D c = new Canvas3D(gcn);
		Jun27_Ilumoff n = new Jun27_Ilumoff(c);
JFrame frm = new JFrame("Jun27_Ilumoff");
Container ct = frm.getContentPane();
c.addKeyListener(keyboard);
ct.add(c);
frm.setSize(1000,800);
frm.setVisible(true);
frm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
}
}
